--[[ABOUT: 
Script Title: Water Submerging
Script Author: iLoveUS
Script Version: 1
Script Next Update: NSS (Not so sure.)
Script Bugs Count: Thousands
Script Author Comments: Low-Medium.
]]

--[[The Script at this case(a lot of bugs affecting armors) is recommended
only to be used in standard modes, or anything that prevents players equipping
armors(like medics,heavyarmor,lightarmor, etc. but not kevlar and helm).]]

--[[Bugs:
Last Armor feature only supports kevlar and helm
and it will not support other armors such as medic,superamor,heavy etc.

Submerging while equipping those armors will cause unfair bugs for players,
for example.

If a player equips a heavyarmor and submerges
and an enemy hitted him, the player's armor will not take effect.
The player will be just like a Unarmored player in water.

Using "equip" command in the console while underwater will also cause
unfair bugs such as no stealth equipped underwater and stealth still equipped
even not underwater, and in most cases, doubled armors or spammed armors using
submerging and emerging while equipped with armors (not kevlar and helm)

]]

--[[If you want to help me solve the bugs, you can PM me (iLoveUS)
how to fix the bugs so I can fix it, please tell me so I can reupload a new update, you can
also send me the fixed script by messaging me the link. Thanks!]]

--[[found BUGS? wha? Bugs again? just PM me (iLoveUS)]]

function initArray(m)									
	local array = {}								    
	for i = 1, m do
		array[i]=0
	end
	return array
end




fades = 1000 --How many milliseconds the water effect fades.


--Leave this thing alone...T_T...pls..:ugly:
uw = initArray(32) --Underwater
lastarmor = initArray(32) --Last Equipped armor before submerging.
abf = initArray(32) --Anti-Bug
uwtwo = initArray(32) --Anti-bug for submerging and emerging at once using one serveraction.
aab = initArray(32) --Anti-Armor Bug
asb = initArray(32) --Anti-Speedmod Bug, prevents interfering with other scripts that uses speedmod.


addhook("spawn","SHIZ") --Some defaults at spawning.
function SHIZ(id) --SHIZ?
	uw[id]=0
	abf[id]=0
	aab[id]=0
	lastarmor[id]=0
	asb[id]=0
	air[id]=10
	ibf[id]=0
end


addhook("serveraction","wannagodown") --Functions in submerging and emerging
function wannagodown(id,c)
	if c == 1 then
		if uw[id] == 0 then
			if abf[id] == 0 then
				if tile(player(id,"tilex"),player(id,"tiley"),"property") == 14 then
					uw[id]=1
					abf[id]=1
					lastarmor[id]=player(id,"armor")
					parse("setarmor "..id.." "..lastarmor[id].."")
					msg2(id,"255255255You are now submerge!")
					parse("equip "..id.." 84")
					img[id] = image("gfx/underwater/uweffect.png",0,1,(132+id),id)
					soundup(id)
				else
					msg2(id,"255000000You can't submerge here.")
				end
			end
		end
	end
	if c == 1 then
		if uw[id] == 1 then
			if abf[id] == 0 then
				if tile(player(id,"tilex"),player(id,"tiley"),"property") == 14 then					
					uw[id]=0
					abf[id]=1
					parse("setarmor "..id.." "..lastarmor[id].."")
					tween_alpha(img[id],fades,0)
					soundup(id)
				end
			end
		end
	end
end

function soundup(id) --Random sounds when emerging and submerging in the water
	shufs=math.random(1,4) --Same as walking in the water sound
		if shufs == 1 then --I recopied it, incase you don't have it :ugly:
			parse("sv_sound2 "..id.." waterup/1up.wav")
		end
		if shufs == 2 then
			parse("sv_sound2 "..id.." waterup/2up.wav")
		end
		if shufs == 3 then
			parse("sv_sound2 "..id.." waterup/3up.wav")
		end
		if shufs == 4 then
			parse("sv_sound2 "..id.." waterup/4up.wav")
		end
	end
			

addhook("ms100","secondo") --A part of anti-bug of emerging and submerging
function secondo() --Because without this, emerging and submerging will never work >:D
	for id = 1,32 do
		abf[id]=0
	end
end

addhook("always","wtfyougoup") --Removing armor when not underwater
function wtfyougoup()
	for id = 1,32 do
		if uw[id] == 1 then
			if tile(player(id,"tilex"),player(id,"tiley"),"property") == 14 then
		else
			parse("setarmor "..id.." "..lastarmor[id].."")
			uw[id]=0
			tween_alpha(img[id],fades,0)
			end
		end
	end
end

addhook("always","secure") --Securing that the armor is removed..
function secure() --Dunno if this works, but I feel it. :ugly:
	for id = 1,32 do	
		if uw[id] == 0 then
			if aab[id] == 1 then
				parse("setarmor "..id.." "..lastarmor[id].."")
				aab[id]=0
			end
		end
	end
end

addhook("walkover","nopeyoucantpickthat") --Preventing to collect all items when underwater
function nopeyoucantpickthat(id) --Minimizing the bug when underwater and collecting armors
	if uw[id] == 1 then --That may remove the underwater effect (stealth armor) 
		return 1
	end
end

addhook("buy","nobuyingpls") --Prevents from buying something in the shop (specifically kevlars and helm)
function nobuyingpls(id) --because it is same as using the equip command that may cause
	if uw[id] == 1 then --unfair bugs, such as equipped stealth even not underwater
		msg2(id,"255255255You have to emerge from the water first!") --or no stealth underwater.
		return 1
	end
end



addhook("always","heheslow") --Hehe slow, ?.slows when underwater
function heheslow() --piece of advice, you better hold shift so you will be more undetectable!!!
	for id = 1,32 do --because water trails will make you more detectable when not pressing shift
		if uw[id] == 1 then
			if asb[id] == 0 then
				parse("speedmod "..id.." -15")
				asb[id]=1
			end
		end
		if uw[id] == 0 then
			if asb[id] == 1 then
				parse("speedmod "..id.." 0")
				asb[id]=0
			end
		end
	end
end

addhook("die","hmhmyoudead") --prevent stealth spam
function hmhmyoudead(id)
	if uw[id] == 1 then
		return 1
	end
end

--BUUUUUUUUUUUUUUUUUBLES :D :D :D


--whut?! arrays again?!
air = initArray(32)
one = initArray(32)
two = initArray(32)
three = initArray(32)
four = initArray(32)
five = initArray(32)

ibf = initArray(32)

img = initArray(32)

addhook("always","bubs") --bubbles!!! from minecraft, sorry I didn't add the popping effect..
function bubs()
	for id = 1,32 do
		if ibf[id] == 0 then
			if air[id] == 10 then
					freeimage(one[id])
					freeimage(two[id])
					freeimage(three[id])
					freeimage(four[id])
					freeimage(five[id])
					one[id]=image("gfx/underwater/bubble.png",15,120,1+id,id)
					two[id]=image("gfx/underwater/bubble.png",15,140,1+id,id)
					three[id]=image("gfx/underwater/bubble.png",15,160,1+id,id)
					four[id]=image("gfx/underwater/bubble.png",15,180,1+id,id)
					five[id]=image("gfx/underwater/bubble.png",15,200,1+id,id)
					ibf[id]=1
				end
				if air[id] == 8 then
					freeimage(one[id])
					freeimage(two[id])
					freeimage(three[id])
					freeimage(four[id])
					freeimage(five[id])
					one[id]=image("gfx/underwater/bubble.png",15,120,1+id,id)
					two[id]=image("gfx/underwater/bubble.png",15,140,1+id,id)
					three[id]=image("gfx/underwater/bubble.png",15,160,1+id,id)
					four[id]=image("gfx/underwater/bubble.png",15,180,1+id,id)
					ibf[id]=1
				end
				if air[id] == 6 then		
					freeimage(one[id])
					freeimage(two[id])
					freeimage(three[id])
					freeimage(four[id])
					freeimage(five[id])
					one[id]=image("gfx/underwater/bubble.png",15,120,1+id,id)
					two[id]=image("gfx/underwater/bubble.png",15,140,1+id,id)
					three[id]=image("gfx/underwater/bubble.png",15,160,1+id,id)
					ibf[id]=1
				end
				if air[id] == 4 then
					freeimage(one[id])
					freeimage(two[id])
					freeimage(three[id])
					freeimage(four[id])
					freeimage(five[id])
					one[id]=image("gfx/underwater/bubble.png",15,120,1+id,id)
					two[id]=image("gfx/underwater/bubble.png",15,140,1+id,id)
					ibf[id]=1
				end
				if air[id] == 2 then
					freeimage(one[id])
					freeimage(two[id])
					freeimage(three[id])
					freeimage(four[id])
					freeimage(five[id])
					one[id]=image("gfx/underwater/bubble.png",15,120,1+id,id)
					ibf[id]=1
				end
				if air[id] == 1 then
					freeimage(one[id])
					freeimage(two[id])
					freeimage(three[id])
					freeimage(four[id])
					freeimage(five[id])
					ibf[id]=1
				end
			end
		end
	end


--Out of bubbles? then drown!!!!!!!!!!!!
addhook("second","drainbubs2")
function drainbubs2()
	for id = 1,32 do
		if uw[id] == 1 then
			if air[id] >= 1 then
				air[id]=air[id]-1
				ibf[id]=0
			end
			if air[id] == 0 then
				parse("sethealth "..id.." "..(player(id,"health")-2))
			end
		end
		if uw[id] == 0 then
			if air[id] < 10 then
				air[id]=air[id]+2
				ibf[id]=0
			end
		end
	end
end



